/*
 * File: app/view/editServices.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.editServices', {
	extend: 'Ext.panel.Panel',

	requires: [
		'Ext.form.Label',
		'Ext.form.Panel',
		'Ext.form.field.Number',
		'Ext.form.field.ComboBox',
		'Ext.grid.Panel',
		'Ext.grid.column.Action',
		'Ext.toolbar.Toolbar',
		'Ext.toolbar.Spacer',
		'Ext.button.Button',
		'Ext.grid.View',
		'Ext.grid.plugin.CellEditing'
	],

	id: 'editServices',
	shadow: false,
	frameHeader: false,
	header: false,
	title: 'Selecione os serviços a monitorar e defina seus parâmetros',

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'panel',
					resize: function() {
						var w = Ext.getCmp("serviceQuantColumn5").getWidth();
						w += Ext.getCmp("serviceNameColumn5").getWidth();
						Ext.getCmp("labelContainer7").setWidth(--w);
					},
					flex: 0,
					id: 'modalHeader4',
					header: false,
					title: 'Selecione os serviços a monitorar e defina seus parâmetros',
					layout: {
						type: 'hbox',
						align: 'stretch',
						padding: '20 20 0'
					},
					items: [
						{
							xtype: 'container',
							flex: 0,
							cls: 'dark-grey-bg',
							id: 'labelContainer7',
							width: 200,
							layout: {
								type: 'vbox',
								align: 'stretch',
								padding: '0 5 5'
							},
							items: [
								{
									xtype: 'label',
									flex: 1,
									cls: 'bold',
									id: 'headerLabel6',
									padding: '4 0 0',
									text: 'Defina os parâmetros dos serviços',
									listeners: {
										beforerender: {
											fn: me.onHeaderLabel6BeforeRender,
											scope: me
										}
									}
								}
							]
						},
						{
							xtype: 'container',
							flex: 1,
							cls: 'grey-bg',
							id: 'labelContainer8',
							layout: {
								type: 'vbox',
								align: 'stretch',
								padding: '0 5 5'
							},
							items: [
								{
									xtype: 'label',
									flex: 1,
									id: 'headerLabel7',
									padding: '4 0 0',
									text: 'Aplicar a todos serviços',
									listeners: {
										beforerender: {
											fn: me.onHeaderLabel7BeforeRender,
											scope: me
										}
									}
								},
								{
									xtype: 'form',
									flex: 1,
									cls: 'grey-bg',
									id: 'selectToAll4',
									bodyCls: [
										'grey-bg',
										'x-panel-body-default',
										'x-box-layout-ct'
									],
									header: false,
									title: 'My Panel',
									layout: {
										type: 'hbox',
										align: 'stretch'
									},
									items: [
										{
											xtype: 'numberfield',
											flex: 0,
											id: 'editTimePeriodAll4',
											margin: '0 6 2 0',
											maxWidth: 63,
											fieldLabel: 'Aplicar a todos',
											hideLabel: true,
											labelAlign: 'top',
											labelSeparator: ' ',
											labelStyle: 'font-size:10px; line-height:12px;',
											labelWidth: 67,
											minValue: 1,
											step: 5,
											listeners: {
												change: {
													fn: me.onNumberfieldChange,
													scope: me
												}
											}
										},
										{
											xtype: 'combobox',
											flex: 0,
											id: 'ediCheckPeriodAll4',
											margin: '0 6 2 0',
											maxWidth: 63,
											fieldLabel: 'Label',
											hideLabel: true,
											labelAlign: 'top',
											labelWidth: 69,
											displayField: 'timeperiod_name',
											queryMode: 'local',
											store: 'timePeriodStore',
											valueField: 'timeperiod_id',
											listeners: {
												change: {
													fn: me.onComboboxChange,
													scope: me
												}
											}
										},
										{
											xtype: 'combobox',
											flex: 1,
											id: 'editHostGroupsAll4',
											margin: '0 0 2',
											fieldLabel: ' ',
											hideLabel: true,
											labelAlign: 'top',
											labelSeparator: ' ',
											displayField: 'servicegroup_name',
											multiSelect: true,
											queryMode: 'local',
											store: 'serviceGroupStore',
											valueField: 'servicegroup_id',
											listeners: {
												change: {
													fn: me.onComboboxChange1,
													scope: me
												}
											}
										}
									]
								}
							]
						}
					]
				},
				{
					xtype: 'gridpanel',
					flex: 1,
					id: 'serviceGrid1',
					padding: '0 20 20',
					autoScroll: true,
					header: false,
					hideCollapseTool: true,
					title: 'My Grid Panel',
					titleCollapse: false,
					columnLines: false,
					enableColumnHide: false,
					enableColumnMove: false,
					forceFit: true,
					scroll: 'vertical',
					store: 'serviceStore',
					columns: [
						{
							xtype: 'gridcolumn',
							id: 'serviceQuantColumn5',
							maxWidth: 28,
							minWidth: 28,
							width: 28,
							resizable: false,
							sortable: false,
							dataIndex: 'count',
							text: '#'
						},
						{
							xtype: 'gridcolumn',
							id: 'serviceNameColumn5',
							width: 310,
							dataIndex: 'service_description',
							text: 'Nome do Serviço',
							flex: 6,
							editor: {
								xtype: 'textfield',
								id: 'editServiceName5',
								validateOnChange: false,
								enableKeyEvents: true,
								listeners: {
									blur: {
										fn: me.onEditServiceName5Blur,
										scope: me
									}
								}
							},
							listeners: {
								beforerender: {
									fn: me.onServiceNameColumn5BeforeRender,
									scope: me
								},
								resize: {
									fn: me.onServiceNameColumn5Resize,
									scope: me
								}
							}
						},
						{
							xtype: 'gridcolumn',
							id: 'checkAllColumn5',
							maxWidth: 200,
							width: 200,
							resizable: false,
							text: 'Checagem',
							columns: [
								{
									xtype: 'gridcolumn',
									draggable: false,
									frame: false,
									id: 'timePeriodColumn5',
									dataIndex: 'normal_check_interval',
									menuText: 'OOOO',
									text: 'Intervalo',
									flex: 2,
									editor: {
										xtype: 'numberfield',
										id: 'editTimePeriod5',
										autoStripChars: true,
										decimalPrecision: 0,
										minValue: 1
									},
									listeners: {
										beforerender: {
											fn: me.onTimePeriodColumn5BeforeRender,
											scope: me
										}
									}
								},
								{
									xtype: 'gridcolumn',
									renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
										var timeperiods;
										var tp;
										var i;
										var me;

										timeperiods = Wizard.getApplication().getTimePeriodStoreStore();
										if (timeperiods.isLoading()) {
											me = this;
											setTimeout(
											function() {
												me.getView().refresh();
											},
											300
											);
											return " ";
										}

										if (value === undefined) {
											value = record.data.check_period;
										}

										for(i=0; i<timeperiods.data.items.length; i++) {
											tp = timeperiods.data.items[i].data;
											if (tp.id == value)
											return tp.timeperiod_name;
										}

										return " ";
									},
									draggable: false,
									id: 'checkPeriodColumn5',
									width: 72,
									dataIndex: 'check_period',
									text: 'Período',
									flex: 2,
									editor: {
										xtype: 'combobox',
										id: 'editCheckPeriod5',
										displayField: 'timeperiod_name',
										queryMode: 'local',
										store: 'timePeriodStore',
										valueField: 'timeperiod_id'
									},
									listeners: {
										beforerender: {
											fn: me.onCheckPeriodColumn5BeforeRender,
											scope: me
										}
									}
								}
							],
							listeners: {
								beforerender: {
									fn: me.onCheckAllColumn5BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'gridcolumn',
							renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
								var i;
								var servicegroups;
								var servicegroup;
								var label = new Array();
								var me;

								servicegroups = Wizard.getApplication().getServiceGroupStoreStore();
								if (servicegroups.isLoading()) {
									me = this;
									setTimeout(
									function() {
										me.getView().refresh();
									},
									300
									);
									return null;
								}

								if (record.data.servicegroups.length === 0) {
									return null;
								}

								for(i=0; i<record.data.servicegroups.length; i++) {
									servicegroup = servicegroups.getById(record.data.servicegroups[i]);
									if (servicegroup !== null) {
										label.push(servicegroup.data.servicegroup_name);
									}
								}

								if (label.length == 0) {
									return null;
								}

								return label.join(", ");
							},
							id: 'serviceGroupsColumn5',
							resizable: false,
							dataIndex: 'servicegroups',
							menuText: 'Texto',
							text: 'Grupos de Serviço',
							flex: 6,
							editor: {
								xtype: 'combobox',
								id: 'editServiceGroups5',
								labelPad: 0,
								displayField: 'servicegroup_name',
								enableRegEx: false,
								multiSelect: true,
								queryMode: 'local',
								store: 'serviceGroupStore',
								valueField: 'servicegroup_id'
							},
							listeners: {
								beforerender: {
									fn: me.onServiceGroupsColumn5BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'actioncolumn',
							margin: '0 16 0 0',
							maxWidth: 35,
							defaultWidth: 50,
							items: [
								{
									handler: function(view, rowIndex, colIndex, item, e, record, row) {
										var svcbucket = Ext.clone(record.data);
										var w = Ext.create("Wizard.view.selectCommand");
										var svckey = record.get("original_check_command")+"-"+record.get("original_service_description");

										w.addServiceBucket(svcbucket);
										w.setCallBack(function(update, updatedsvc){

											/**
											* we only sent one service to `selectCommand'
											* screen, now we have to update all services
											* that share the same check command and service
											* description if something has changed, of course
											*/
											var i;

											if (me.groupedServices[svckey] === undefined) /* not supposed to happen */
											return;

											if (!update)
											return;

											/* update records on grid */
											record.set("check_command",svcbucket.check_command);
											record.set("check_parameters",svcbucket.check_parameters);

											for(i in me.groupedServices[svckey].services) {
												me.groupedServices[svckey].services[i].check_command = svcbucket.check_command;
												me.groupedServices[svckey].services[i].check_parameters = svcbucket.check_parameters;
											}
										});
										w.show();
									},
									icon: '/opmon/seagull/modules/statusgrid/templates/imgs/ico-editar.png'
								}
							]
						}
					],
					dockedItems: [
						{
							xtype: 'toolbar',
							dock: 'bottom',
							id: 'editGroupsBar5',
							items: [
								{
									xtype: 'tbspacer',
									flex: 1
								},
								{
									xtype: 'button',
									handler: function(button, event) {
										makeActiveView("servicesContacts");

										var me = Ext.getCmp("editServices");
										var w = Ext.getCmp("servicesContacts");
										w.last_view = "editServices";
										w.groupedServices = me.groupedServices;
										w.callback = function(newGroupedServices) {
											/* now with the contact/contactgroup changes */
											me.groupedServices = newGroupedServices;
										};
									},
									id: 'editContactsBtn7',
									text: 'Alterar Equipes e Responsáveis',
									listeners: {
										beforerender: {
											fn: me.onEditGroupsBtn5BeforeRender1,
											scope: me
										}
									}
								},
								{
									xtype: 'button',
									handler: function(button, event) {
										makeActiveView("editGroupsPanel");
									},
									id: 'editGroupsBtn5',
									text: 'Editar Grupos de Serviço',
									listeners: {
										beforerender: {
											fn: me.onEditGroupsBtn5BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					],
					viewConfig: {
						minHeight: 250
					},
					plugins: [
						Ext.create('Ext.grid.plugin.CellEditing', {
							clicksToEdit: 1,
							listeners: {
								validateedit: {
									fn: me.onCellEditingValidateedit,
									scope: me
								},
								beforeedit: {
									fn: me.onCellEditingBeforeEdit,
									scope: me
								}
							}
						})
					]
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					flex: 1,
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar14',
					items: [
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										me = Ext.getCmp('editServices');

										var services = Wizard.getApplication().getServiceStoreStore();
										for(var i=0; i<services.getCount(); i++) {
											svc = services.getAt(i);
											if (svc.get("contactgroups").length === 0 && svc.get("contacts").length === 0) {
												showError(l["Invalid Configuration"],l["All services must contain at least one user or team responsible"]);
												return;
											}
										}

										/* get final version of services after all editions */
										var updatedServices = [];
										for(i in me.groupedServices) {
											for(var j in me.groupedServices[i].services) {
												updatedServices.push(me.groupedServices[i].services[j]);
											}
										}

										if (me.running) {showError(l['Unexpected error'], l['Updating']);return;}
										Ext.MessageBox.confirm(l.Confirmation, l['Do you really want to apply all the changes ?'], function(btn){

											if(btn !== 'yes')
											return;
											me.running = true;

											Ext.Ajax.request({
												url: '/opmon/seagull/www/index.php/discovery/action/saveservices/',
												method: 'POST',
												params: {
													services: JSON.stringify(updatedServices)
												},
												success: function(result, request) {
													var wsreturn;

													try {
														wsreturn = JSON.parse(result.responseText);
													} catch(err) {
														showError(l["Unexpected error"],err.message);
														me.running = false;
														return;
													}

													if (!wsreturn.success) {
														showError(l["Unexpected error"], wsreturn.message);
														me.running = false;
														return;
													}

													if (Wizard.endCallBack) {
														func = "parent."+Wizard.endCallBack+"(true);";
														me.running = false;
														eval(func);
													}

												},
												failure: function(object, request) {
													me.running = false;
													showError(l.Error,l["Unexpected error"], request.responseText, request);
												}

											});

										});
									},
									id: 'nextBtn14',
									text: 'Salvar alterações',
									listeners: {
										beforerender: {
											fn: me.onNextBtn14BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			],
			listeners: {
				resize: {
					fn: me.onEditServicesResize,
					scope: me
				}
			}
		});

		me.callParent(arguments);
	},

	onHeaderLabel6BeforeRender: function(component, eOpts) {
		component.html = l["Set the services parameters"];
	},

	onHeaderLabel7BeforeRender: function(component, eOpts) {
		component.text = l["Apply to all services"];
	},

	onNumberfieldChange: function(field, newValue, oldValue, eOpts) {
		var services;
		var service;
		var i;
		var grid;
		var svckey;
		var j;

		me = Ext.getCmp("editServices");
		services = Wizard.getApplication().getServiceStoreStore();
		for(i=0; i<services.data.items.length; i++) {
			service = services.data.items[i];
			service.data.normal_check_interval = newValue;

			/**
			* a service on grid may represent a group
			* of services with the same check command
			* and service description. above we just
			* updated the service on the grid, below we
			* gonna update all services on the same
			* group
			*/
			svckey = service.get("original_check_command")+"-"+service.get("original_service_description");
			if (me.groupedServices[svckey] === undefined) /* this is not supposed to happen */
				continue;

			for(j in me.groupedServices[svckey].services) {
				me.groupedServices[svckey].services[j].normal_check_interval = newValue;
			}

		}

		grid = Ext.getCmp("serviceGrid1");
		grid.getView().refresh();
	},

	onComboboxChange: function(field, newValue, oldValue, eOpts) {
		var services;
		var service;
		var i;
		var grid;
		var svckey;
		var j;

		me = Ext.getCmp("editServices");
		services = Wizard.getApplication().getServiceStoreStore();
		for(i=0; i<services.data.items.length; i++) {
			service = services.data.items[i];
			service.data.check_period = newValue;

			/**
			* a service on grid may represent a group
			* of services with the same check command
			* and service description. above we just
			* updated the service on the grid, below we
			* gonna update all services on the same
			* group
			*/
			svckey = service.get("original_check_command")+"-"+service.get("original_service_description");
			if (me.groupedServices[svckey] === undefined) /* this is not supposed to happen */
				continue;

			for(j in me.groupedServices[svckey].services) {
				me.groupedServices[svckey].services[j].check_period = newValue;
			}


		}

		grid = Ext.getCmp("serviceGrid1");
		grid.getView().refresh();
	},

	onComboboxChange1: function(field, newValue, oldValue, eOpts) {
		var services;
		var service;
		var i;
		var grid;
		var svckey;
		var j;

		me = Ext.getCmp("editServices");
		services = Wizard.getApplication().getServiceStoreStore();
		for(i=0; i<services.data.items.length; i++) {
			service = services.data.items[i];
			service.data.servicegroups = newValue;

			/**
			* a service on grid may represent a group
			* of services with the same check command
			* and service description. above we just
			* updated the service on the grid, below we
			* gonna update all services on the same
			* group
			*/
			svckey = service.get("original_check_command")+"-"+service.get("original_service_description");
			if (me.groupedServices[svckey] === undefined) /* this is not supposed to happen */
				continue;

			for(j in me.groupedServices[svckey].services) {
				me.groupedServices[svckey].services[j].servicegroups = newValue;
			}
		}

		grid = Ext.getCmp("serviceGrid1");
		grid.getView().refresh();
	},

	onEditServiceName5Blur: function(component, e, eOpts) {
		component.setValue(
			changeCharCode(component.getValue())
		);
	},

	onServiceNameColumn5BeforeRender: function(component, eOpts) {
		component.text = l["Service Name"];
	},

	onServiceNameColumn5Resize: function(component, width, height, oldWidth, oldHeight, eOpts) {
		Ext.getCmp("modalHeader4").resize();
	},

	onTimePeriodColumn5BeforeRender: function(component, eOpts) {
		component.text = l["Interval"];
		component.tooltip = l["Interval"];
	},

	onCheckPeriodColumn5BeforeRender: function(component, eOpts) {
		component.text = l["Period"];
		component.tooltip = l["Period"];
	},

	onCheckAllColumn5BeforeRender: function(component, eOpts) {
		component.text = l["Check"];
	},

	onServiceGroupsColumn5BeforeRender: function(component, eOpts) {
		component.text = l["Service Groups"];
	},

	onEditGroupsBtn5BeforeRender1: function(component, eOpts) {
		component.text = l["Change Teams and Team members"];//ñ sei se a tradução existe =)
	},

	onEditGroupsBtn5BeforeRender: function(component, eOpts) {
		component.text = l["Edit Service Groups"];
	},

	onCellEditingValidateedit: function(editor, e, eOpts) {
		/**
		* something has changed on the grid, we have
		* to determine which record has been changed
		* and which property, once we detect that, we
		* have to update all services that have the
		* same check command and service description
		*
		* we group services by check command and service
		* description and keep a track of them on
		* `groupedServices' property of `editServices'
		* window
		*/

		if (e.value === e.originalValue) /* nothing has changed */
			return;

		var me = Ext.getCmp("editServices");
		var svcidx = e.record.get("original_check_command")+"-"+e.record.get("original_service_description");

		/* this is not supposed to happen */
		if (me.groupedServices[svcidx] === undefined)
			return;

		/* update all group services */
		var group = me.groupedServices[svcidx];
		Ext.each(group.services, function(svc){
			svc[e.field] = e.value;
		});
	},

	onCellEditingBeforeEdit: function(editor, e, eOpts) {
		if (e.record.get('is_scat')) {
			if (e.field === 'service_description') {
				return false;
			}
		}
	},

	onNextBtn14BeforeRender: function(component, eOpts) {
		component.text = l["Save Changes"];
	},

	onEditServicesResize: function(component, width, height, oldWidth, oldHeight, eOpts) {
		Ext.getCmp("modalHeader4").resize();
	}

});