/*
 * File: app/view/model/panel.js
 *
 * This file was generated by Sencha Architect version 3.2.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 5.1.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 5.1.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.model.panel', {
	extend: 'Ext.panel.Panel',
	alias: 'widget.modelpanel',

	requires: [
		'model_wiz.view.model.panelViewModel',
		'model_wiz.view.model.step',
		'Ext.tab.Panel',
		'Ext.tab.Bar',
		'Ext.form.Panel',
		'Ext.tab.Tab',
		'Ext.toolbar.Toolbar',
		'Ext.button.Segmented'
	],

	config: {
		hosts: '[]',
		beingedited: ''
	},

	viewModel: {
		type: 'modelpanel'
	},
	layout: 'hbox',
	hideCollapseTool: true,
	title: '{{Model Name}}',
	defaultListenerScope: true,

	items: [
		{
			xtype: 'container',
			flex: 1,
			padding: '8 0 0 0',
			layout: {
				type: 'vbox',
				align: 'stretch'
			},
			items: [
				{
					xtype: 'tabpanel',
					height: 36,
					hidden: true,
					margin: '0 6',
					maxHeight: 36,
					activeTab: 0,
					plain: true,
					tabBar: {
						xtype: 'tabbar',
						cls: 'aoptabs-fakemenu'
					},
					listeners: {
						beforeshow: 'onTabpanelBeforeShow',
						hide: 'onTabpanelHide'
					}
				},
				{
					xtype: 'tabpanel',
					flex: 1,
					cls: 'opsubpanel',
					margin: '0 0 0 6',
					header: false,
					headerPosition: 'right',
					title: 'model steps',
					titleAlign: 'right',
					titleCollapse: false,
					titleRotation: 0,
					activeTab: 0,
					plain: true,
					tabBar: {
						xtype: 'tabbar',
						cls: 'optabs-fakemenu',
						margin: '0 10 0 0',
						modelValidation: false,
						plain: true,
						tabRotation: 0,
						listeners: {
							change: 'onTabbarChange'
						}
					},
					items: [
						{
							xtype: 'modelstep',
							title: 'Key parameters'
						},
						{
							xtype: 'modelstep',
							title: 'Memmory'
						},
						{
							xtype: 'modelstep',
							title: 'CPU'
						}
					],
					listeners: {
						boxready: 'onStep_03_contentBoxReady'
					}
				}
			]
		},
		{
			xtype: 'toolbar',
			padding: '6 0 6 6 ',
			items: [
				{
					xtype: 'segmentedbutton',
					items: [
						{
							toggleHandler: function(button, state) {
								var el_parent = button.findParentByType('modelpanel');
								var each_host_tabs = el_parent.items.items[0].items.items[0].id;
								var model_steps_tabs = el_parent.items.items[0].items.items[1].id;
								var tabs = Ext.getCmp(model_steps_tabs).tabBar.items.items;
								if (state) {
									Ext.getCmp(each_host_tabs).show();
									for (var i = 0; i < tabs.length; i++) {
										var el  = tabs[i].id;
										Ext.getCmp(el).addCls("tab-one-by-one");
										Ext.getCmp(el).removeCls("tab-for-all");
									}
								} else {
									Ext.getCmp(each_host_tabs).hide();
									for (var i = 0; i < tabs.length; i++) {
										var el  = tabs[i].id;
										Ext.getCmp(el).removeCls("tab-one-by-one");
										Ext.getCmp(el).addCls("tab-for-all");
									}
								}
							},
							allowDepress: false,
							text: '{{Setup by host}}'
						},
						{
							allowDepress: false,
							enableToggle: true,
							pressed: true,
							text: '{{Setup all hosts}}'
						}
					]
				}
			]
		}
	],

	onTabpanelBeforeShow: function(component, eOpts) {
		var selected_hosts = Ext.getStore('selected_hosts_store');
		var hosts = selected_hosts.getData().items;
		for (var i = 0; i < hosts.length; i++) {
			var new_panel = Ext.create('Ext.panel.Panel', {
				title: hosts[i].data.hostname,
				width: 200,
			});
			component.add(new_panel);
		}
		component.setActiveTab(0);
		console.log(component);
	},

	onTabpanelHide: function(component, eOpts) {
		component.removeAll();
	},

	onTabbarChange: function(tabBar, tab, card, eOpts) {
		tab.addCls("tab-done");
	},

	onStep_03_contentBoxReady: function(component, width, height, eOpts) {
		Ext.getCmp(component.tabBar.activeTab.id).addCls("tab-done");
		var tabs = component.tabBar.items.items;
		for (var i = 0; i < tabs.length; i++) {
			var el  = tabs[i].id;
			Ext.getCmp(el).addCls("tab-for-all");
		}
	},

	forward: function(child,event) {
		if (event === 'record') {
			console.log('recording ' + child.id + ' data...');
		} else {
			console.log('requiring data for ' + child.id + '...');
		}

	}

});